<?php
include_once("test_common.php");

// default is use of typed object with original class
function amfphp_serialize_callback($value,$event)
{
	switch($event)
	{
	case AMFE_MAP:
		if(is_resource($value))
			return "";
		$className = strtolower(get_class($value));
		if($className == 'mybytearray')
		{
			echo("custom mybytearray!\n");
			return array($value->data,AMFC_BYTEARRAY);
		}
		break;
	case AMFE_TRANSLATE_CHARSET:
		echo "AMFE_TRANSLATE_CHARSET serialize <$arg>\n";
		break;
	default:
		echo "unknown $event serialize";
		return;
	}
}

class myByteArray
{
    var $data = "Hello ByteArray Data";
};

function amfphp_unserialize_callback($event, &$arg)
{
    switch($event)
    {
    case AMFE_POST_BYTEARRAY:    
        echo("Post Bytearray wrap as myByteArray class\n");
        $r = new myByteArray();
        $r->data = $arg;
        return $r;
    case AMFE_TRANSLATE_CHARSET:
		echo "AMFE_TRANSLATE_CHARSET unserialize <$arg>\n";
		break;
	case AMFE_MAP:
		break;
    default:
		echo "unknown $event unserialize";
		break;
	}
}

$test3 = 1;
$test0 = 1;

$defaultFlags = AMF_TRANSLATE_CHARSET_NOASCII; //AMF_TRANSLATE_CHARSET;
test(new myByteArray());

?>